package edu.usc.ict.iago.agent;

import edu.usc.ict.iago.utils.Event;
import edu.usc.ict.iago.utils.ExpressionPolicy;
import edu.usc.ict.iago.utils.History;
import edu.usc.ict.iago.utils.Offer;

@SuppressWarnings("unused")
public class IAGONiceExpression implements ExpressionPolicy 
{
	
	protected IAGONiceExpression (AgentUtilsExtension utils)
	{
		this.utils = utils;
	}
	
	private AgentUtilsExtension utils;

	@Override
	public String getExpression(History history) 
	{
		Event last = history.getPlayerHistory().getLast();
		//our basic version is ignorant of history
		//it simply mirrors your action
		if(last.getType().equals(Event.EventClass.SEND_EXPRESSION)){
			if(last.getMessage().equals("sad"))
				return "sad";
				//return "AU,Sad,All,1.0,5";//syntax for vhtoolkit, if you're running it
			if(last.getMessage().equals("happy"))
				return "happy";
				//return "AU,Happy,All,1.0,5";//syntax for vhtoolkit, if you're running it
			if(last.getMessage().equals("surprised"))
				return "neutral";
				//return "AU,Surprised,All,1.0,5";//syntax for vhtoolkit, if you're running it
			if(last.getMessage().equals("angry"))
				return "sad";
				//return "AU,Angry,All,1.0,5";//syntax for vhtoolkit, if you're running it
		} 
		else if (last.getType().equals(Event.EventClass.SEND_MESSAGE))
		{
			if(last.getMessageCode() > -1)
			{
				switch(last.getMessageCode())
				{
					case 1:
					case 3:
					case 4:
					case 9:
					case 11:
						return "happy";
					case 2:
					case 5:
					case 6:
					case 7:
					case 8:
					case 10:
						return "sad";
				}
			}
		}
//		else if (last.getType().equals(Event.EventClass.SEND_OFFER))//smiles when offer is better than previous, sad otherwise
//		{
//			Event search0 = utils.lastEvent(utils.getHistory().getHistory(), Event.EventClass.SEND_OFFER);
//			Offer search0Offer = search0 == null ? null : search0.getOffer();
//			Event search1 = utils.secondLastEvent(utils.getHistory().getHistory(), Event.EventClass.SEND_OFFER);
//			Offer search1Offer = search1 == null ? null : search1.getOffer();
//			if (search0Offer != null && search1Offer != null)
//			{
//				if (utils.myActualOfferValue(search0Offer) > utils.myActualOfferValue(search1Offer))
//					return "happy";
//				else
//					return "sad";
//			}
//		}
		return "";
		
	}

}
